import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Arrow_Button here.
 * 
 * @author Gevater_Tod4711
 * @version 1.1
 */
public class Arrow_Button extends Menu
{
    private String direction;
    
    private NumberField numberField;
    
    private long time;
    private long startingTime;    
    private boolean mouseDown = false;
    
    public Arrow_Button(String direction, NumberField numberField) throws IllegalArgumentException {
        if (direction != "up" && direction != "down") {
            throw new IllegalArgumentException("String direction has to be \"up\" or \"down\"");
        }
        this.direction = direction;
        this.numberField = numberField;
        setImage(new GreenfootImage("arrow_" + direction + ".jpg"));
    }
    
    public Arrow_Button(String direction, NumberField numberField, int width, int height) {
        if (direction != "up" && direction != "down") {
            throw new IllegalArgumentException("String direction has to be \"up\" or \"down\"");
        }
        this.direction = direction;
        this.numberField = numberField;
        setImage(new GreenfootImage("arrow_" + direction + ".jpg"));
        getImage().scale(width, height);
    }
    
    public void act() {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (Greenfoot.mouseClicked(this) && numberField != null) {
            if (!numberField.isActive()) {
                numberField.setActiveNumberField(numberField);
            }
            if (direction == "up") {
                numberField.incrementValue();
            }
            else {
                numberField.decrementValue();
            }
        }
        if(Greenfoot.mousePressed(this)) {
            mouseDown = true;
            time = 0;
        }
        else if(Greenfoot.mouseClicked(null)) {
            mouseDown = false;
        }
        if (mouseDown && mouseOnObject(this)) {
            if (!numberField.isActive()) {
                numberField.setActiveNumberField(numberField);
            }
            if (startingTime == 0) {
                startingTime = System.currentTimeMillis();
            }
            else {
                time = System.currentTimeMillis() - startingTime;
            }
            if (time > 500 && time % 100 == 0) {
                if (direction == "up") {
                    numberField.incrementValue();
                }
                else {
                    numberField.decrementValue();
                }
            }
        }
        else if (Greenfoot.mouseDragEnded(null)) {
            startingTime = 0;
        }
    }
    
    private boolean mouseOnObject(Actor actor) {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        return mouse != null && mouse.getX() > actor.getX() - actor.getImage().getWidth()/2 && mouse.getX() < actor.getX() + actor.getImage().getWidth()/2 && 
            mouse.getY() > actor.getY() - actor.getImage().getHeight()/2 && mouse.getY() < actor.getY() + actor.getImage().getHeight()/2;
    }
}