import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * This class is a superclass for all elements of the game that are in the background of the world like ground, water, plattforms, ...
 * 
 * The images and all other settings of the background objects are to be found in the class Settings.
 * 
 * @author Gevater_Tod4711
 * @version 1.0
 */
public abstract class Background extends Actor
{
    protected int width;
    protected int height;
    
    protected double exactX;
    protected double exactY;
    protected double velX;
    protected double velY;
    
    protected Material material;
    
    public Background(Material material) {
        this.material = material;
    }
    
    public void setLocation(int x, int y) {
        exactX = x;
        exactY = y;
        super.setLocation(x, y);
    }
    public void setLocation(double x, double y) {
        exactX = x;
        exactY = y;
        super.setLocation((int) x, (int) y);
    }
    
    public void setImage(GreenfootImage img) {
        super.setImage(new GreenfootImage(img));
    }
    
    public double getExactX(){
        return exactX;
    }
    public double getExactY(){
        return exactY;
    }
    
    public Material getMaterial() {
        return material;
    }
    
    public int getWidth() {
        return width;
    }
    public int getHeight() {
        return height;
    }
}