import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.IOException;
import java.util.List;
import java.util.ArrayList;

/**
 * An EndGate is the end of a level where the player gets to the next level.
 * If profiles are used the pointscore and the maximum reached level are stored into the players profile.
 * 
 * @author Gevater_Tod4711
 * @version 1.0
 */
public class EndGate extends Actor
{
    private int counter = 0;
    
    public EndGate() {
        if (Settings.endGate != null) {
            setImage(Settings.endGate);
        }
    }
    
    public final void act() {
        if (getWorld().getObjects(BreakMenu.class).isEmpty() && !((GravityWorld) getWorld()).isEditMode()) {
            run();
        }
    }
    
    public void run() {
        if (getOneIntersectingObject(Hero.class) != null) {
            Greenfoot.delay(50);
            if (getWorld().getLevel() == -1) {
                getWorld().removeAllObjectsBut(this);
                getWorld().addObject(new MainMenu(), getWorld().getWidth()/2, getWorld().getHeight()/2);
                getWorld().removeObject(this);
                return;
            }
            Settings.profile.setReachedLevel(getWorld().getLevel() + 1);
            if (!getWorld().nextLevel()) {
                Settings.profile.setReachedLevel(getWorld().getLevel());
                getWorld().removeAllObjectsBut(this);
                getWorld().addObject(new EndScreen(), getWorld().getWidth()/2, getWorld().getHeight()/2);
                getWorld().removeObject(this);
                return;
            }
            try {
                Settings.profile.saveProfile();
            }
            catch (IOException ioe) {
                ioe.printStackTrace();
            }
        }
    }
    
    public GravityWorld getWorld() {
        return (GravityWorld) super.getWorld();
    }
}