import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Hero here.
 * 
 * @author Gevater_Tod4711
 * @version 1.0
 */
public class Hero extends ScrollingActor
{
    private final double maximumMovementAir = Settings.HERO_MAX_MOVEMENT_AIR;
    private final double firstJumpMovement = Settings.HERO_FIRST_JUMP_MOVEMENT;
    
    private double maximumMovement = maximumMovementAir;
    
    private GreenfootImage hero = new GreenfootImage(Settings.hero);
    
    public Hero() {
        setImage(hero);
    }
    
    public void run() {
        if (getWorld().getGravityDirection() != 1 && getWorld().getGravityDirection() != 3) {
            if (Math.abs(velX) < 0.15) {
                velX = 0;
            }
            else {
                if (velX < 0) {
                    velX += 0.15;
                }
                else {
                    velX -= 0.15;
                }
            }
        }
        if (getWorld().getGravityDirection() != 0 && getWorld().getGravityDirection() != 2) {
            if (Math.abs(velY) < 0.15) {
                velY = 0;
            }
            else {
                if (velY < 0) {
                    velY += 0.15;
                }
                else {
                    velY -= 0.15;
                }
            }
        }
        if (isOnEarth()) {
            if (Greenfoot.isKeyDown(Settings.jump)) {
                jump();
            }
        }
        else {
            switch (getWorld().getGravityDirection()) {
                case 0:
                    velY += GravityWorld.GRAVITY;
                    break;
                case 1:
                    velX -= GravityWorld.GRAVITY;
                    break;
                case 2:
                    velY -= GravityWorld.GRAVITY;
                    break;
                case 3:
                    velX += GravityWorld.GRAVITY;
                    break;
            }
        }
        if (Greenfoot.isKeyDown(Settings.setGravityDirectionUp)) {
            getWorld().setGravityDirection(2);
            setRotation(180);
        }
        if (Greenfoot.isKeyDown(Settings.setGravityDirectionDown)) {
            getWorld().setGravityDirection(0);
            setRotation(0);
        }
        if (Greenfoot.isKeyDown(Settings.setGravityDirectionLeft)) {
            getWorld().setGravityDirection(1);
            setRotation(90);
        }
        if (Greenfoot.isKeyDown(Settings.setGravityDirectionRight)) {
            getWorld().setGravityDirection(3);
            setRotation(270);
        }
        if (isOnLava()) {
            respawn();
            return;
        }
        move();
    }
    
    /**
     * Set the hero's location to the given new location if possible.
     * 
     * @param x
     *      The hero's new x location.
     * 
     * @param y
     *      The hero's new y location.
     */
    public void setLocation(int x, int y) {
        if (getWorld().getMaterialNumberAt((int) x, (int) y) != 1 && 
            getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2)) != 1 && 
            getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2)) != 1 && 
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) y) != 1 && 
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) y) != 1 &&
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) != 1) {
            super.setLocation(x, y);
            getWorld().resetPlayersPosition(this);
        }
        else {
            int changeX = 11;
            int changeY = 11;
            boolean xPos = false;
            boolean yPos = false;
            if (getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) y) == 1 || 
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeX = 1; changeX < 10; changeX++) {
                    if (getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) y) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) (y - getImage().getHeight()/2)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) (y + getImage().getHeight()/2)) != 1) {
                        xPos = false;
                        break;
                    }
                }
            }
            else if (getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) y) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeX = 1; changeX < 10; changeX++) {
                    if (getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) y) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) (y - getImage().getHeight()/2)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) (y + getImage().getHeight()/2)) != 1) {
                        xPos = true;
                        break;
                    }
                }
            }
            if (getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2)) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeY = 1; changeY < 10; changeY++) {
                    if (getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2 - changeY)) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2 - changeY)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2 - changeY)) != 1) {
                        yPos = false;
                        break;
                    }
                }
            }
            else if (getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2)) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1) {
                for (changeY = 1; changeY < 10; changeY++) {
                    if (getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2 + changeY)) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2 + changeY)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2 + changeY)) != 1) {
                        yPos = true;
                        break;
                    }
                }
            }
            if (changeX < changeY) {
                if (xPos) {
                    super.setLocation(x + changeX, y);
                    getWorld().resetPlayersPosition(this);
                    velX = 0;
                }
                else {
                    super.setLocation(x - changeX, y);
                    getWorld().resetPlayersPosition(this);
                    velX = 0;
                }
            }
            else if (changeY < changeX) {
                if (yPos) {
                    super.setLocation(x, y + changeY);
                    getWorld().resetPlayersPosition(this);
                    velY = 0;
                }
                else {
                    super.setLocation(x, y - changeY);
                    getWorld().resetPlayersPosition(this);
                    velY = 0;
                }
            }
        }
    }
    /**
     * Set the hero's location to the given new location if possible.
     * All location components are double values.
     * 
     * @param x
     *      The hero's new x location.
     * 
     * @param y
     *      The hero's new y location.
     */
    public void setLocation(double x, double y) {
        if (getWorld().getMaterialNumberAt((int) x, (int) y) != 1 && 
            getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2)) != 1 && 
            getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2)) != 1 && 
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) y) != 1 && 
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) y) != 1 &&
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) != 1) {
            super.setLocation(x, y);
            getWorld().resetPlayersPosition(this);
        }
        else {
            int changeX = 11;
            int changeY = 11;
            boolean xPos = false;
            boolean yPos = false;
            if (getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) y) == 1 || 
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeX = 1; changeX < 10; changeX++) {
                    if (getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) y) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) (y - getImage().getHeight()/2)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) (y + getImage().getHeight()/2)) != 1) {
                        xPos = false;
                        break;
                    }
                }
            }
            else if (getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) y) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeX = 1; changeX < 10; changeX++) {
                    if (getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) y) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) (y - getImage().getHeight()/2)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) (y + getImage().getHeight()/2)) != 1) {
                        xPos = true;
                        break;
                    }
                }
            }
            if (getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2)) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeY = 1; changeY < 10; changeY++) {
                    if (getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2 - changeY)) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2 - changeY)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2 - changeY)) != 1) {
                        yPos = false;
                        break;
                    }
                }
            }
            else if (getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2)) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1) {
                for (changeY = 1; changeY < 10; changeY++) {
                    if (getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2 + changeY)) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2 + changeY)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2 + changeY)) != 1) {
                        yPos = true;
                        break;
                    }
                }
            }
            if (changeX < changeY) {
                if (xPos) {
                    super.setLocation(x + changeX, y);
                    getWorld().resetPlayersPosition(this);
                    velX = 0;
                }
                else {
                    super.setLocation(x - changeX, y);
                    getWorld().resetPlayersPosition(this);
                    velX = 0;
                }
            }
            else if (changeY < changeX) {
                if (yPos) {
                    super.setLocation(x, y + changeY);
                    getWorld().resetPlayersPosition(this);
                    velY = 0;
                }
                else {
                    super.setLocation(x, y - changeY);
                    getWorld().resetPlayersPosition(this);
                    velY = 0;
                }
            }
        }
    }
    /**
     * Set the hero's location to the given new location if possible and decide if the position should be reseted.
     * This method is most times used from the world class for the scrolling system.
     * 
     * @param x
     *      The hero's new x location.
     * 
     * @param y
     *      The hero's new y location.
     * 
     * @param resetPosition
     *      If the position of the hero should be reseted to the center of the screen this value has to be true.
     */
    public void setLocation(double x, double y, boolean resetPosition) {
        if (getWorld().getMaterialNumberAt((int) x, (int) y) != 1 && 
            getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2)) != 1 && 
            getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2)) != 1 && 
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) y) != 1 && 
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) y) != 1 &&
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) != 1 &&
            getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) != 1) {
            super.setLocation(x, y, resetPosition);
            if (resetPosition) {
                getWorld().resetPlayersPosition(this);
            }
        }
        else {
            int changeX = 11;
            int changeY = 11;
            boolean xPos = false;
            boolean yPos = false;
            if (getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) y) == 1 || 
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeX = 1; changeX < 10; changeX++) {
                    if (getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) y) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) (y - getImage().getHeight()/2)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2 - changeX), (int) (y + getImage().getHeight()/2)) != 1) {
                        xPos = false;
                        break;
                    }
                }
            }
            else if (getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) y) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeX = 1; changeX < 10; changeX++) {
                    if (getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) y) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) (y - getImage().getHeight()/2)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2 + changeX), (int) (y + getImage().getHeight()/2)) != 1) {
                        xPos = true;
                        break;
                    }
                }
            }
            if (getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2)) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2)) == 1) {
                for (changeY = 1; changeY < 10; changeY++) {
                    if (getWorld().getMaterialNumberAt((int) x, (int) (y + getImage().getHeight()/2 - changeY)) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y + getImage().getHeight()/2 - changeY)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y + getImage().getHeight()/2 - changeY)) != 1) {
                        yPos = false;
                        break;
                    }
                }
            }
            else if (getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2)) == 1 || 
                getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1 ||
                getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2)) == 1) {
                for (changeY = 1; changeY < 10; changeY++) {
                    if (getWorld().getMaterialNumberAt((int) x, (int) (y - getImage().getHeight()/2 + changeY)) != 1 && 
                        getWorld().getMaterialNumberAt((int) (x - getImage().getWidth()/2), (int) (y - getImage().getHeight()/2 + changeY)) != 1 &&
                        getWorld().getMaterialNumberAt((int) (x + getImage().getWidth()/2), (int) (y - getImage().getHeight()/2 + changeY)) != 1) {
                        yPos = true;
                        break;
                    }
                }
            }
            if (changeX < changeY) {
                if (xPos) {
                    super.setLocation(x + changeX, y, resetPosition);
                    if (resetPosition) {
                        getWorld().resetPlayersPosition(this);
                    }
                    velX = 0;
                }
                else {
                    super.setLocation(x - changeX, y, resetPosition);
                    if (resetPosition) {
                        getWorld().resetPlayersPosition(this);
                    }
                    velX = 0;
                }
            }
            else if (changeY < changeX) {
                if (yPos) {
                    super.setLocation(x, y + changeY, resetPosition);
                    if (resetPosition) {
                        getWorld().resetPlayersPosition(this);
                    }
                    velY = 0;
                }
                else {
                    super.setLocation(x, y - changeY, resetPosition);
                    if (resetPosition) {
                        getWorld().resetPlayersPosition(this);
                    }
                    velY = 0;
                }
            }
        }
    }
    
    public void jump() {
        switch (getWorld().getGravityDirection()) {
            case 0:
                velY = -firstJumpMovement;
                break;
            case 1:
                velX = firstJumpMovement + 1;
                break;
            case 2:
                velY = firstJumpMovement + 1;
                break;
            case 3:
                velX = -firstJumpMovement;
                break;
        }
        if (Settings.jumpSound != null) {
            GreenfootSound sound = new GreenfootSound(Settings.jumpSound);
            sound.setVolume(Settings.soundVolume);
            sound.play();
        }
    }
    
    private void respawn() {
        if (Settings.burnSound != null) {
            GreenfootSound sound = new GreenfootSound(Settings.burnSound);
            sound.setVolume(Settings.soundVolume);
            sound.play();
        }
        Greenfoot.delay(30);
        velX = 0;
        velY = 0;
        getWorld().setGravityDirection(0);
        setRotation(0);
        List<SpawnPoint> spawnPoints = getWorld().getObjects(SpawnPoint.class);
        for (SpawnPoint spawnPoint : spawnPoints) {
            if (spawnPoint.isActivated()) {
                setLocation(spawnPoint.getX(), spawnPoint.getY());
                break;
            }
        }
    }
    
    /**
     * Controll the hero's movement.
     */
    public void move() {
        double xMovement = velX;
        double yMovement = velY;
        if (Math.abs(xMovement) < 0.05) {
            xMovement = 0;
        }
        if (Math.abs(yMovement) < 0.05) {
            yMovement = 0;
        }
        if (Math.abs(velY) > maximumMovement) {
            if (velY > maximumMovement) {
                velY = maximumMovement;
                yMovement = maximumMovement;
            }
            else {
                velY = -maximumMovement;
                yMovement = -maximumMovement;
            }
        }
        if (Math.abs(velX) > maximumMovement) {
            if (velX > maximumMovement) {
                velX = maximumMovement;
                xMovement = maximumMovement;
            }
            else {
                velX = -maximumMovement;
                xMovement = -maximumMovement;
            }
        }
        setLocation(getExactX() + xMovement, getExactY() + yMovement);
    }
    
    /**
     * Check whether the hero is standing on a certain background object.
     * 
     * @param bg
     *      The background object you want to check whether the hero is standing on it.
     * 
     * @return
     *      Returns true if the hero is standing on the given background object. false is returned otherwhise.
     */
    public boolean standingOnObject(Background bg) {
        List<Background> bg1 = getWorld().getObjectsAt(getX(), getY() + getImage().getHeight()/2 + 1, Background.class);
        List<Background> bg2 = getWorld().getObjectsAt(getImage().getWidth()/2, getY() + getImage().getHeight()/2 + 1, Background.class);
        List<Background> bg3 = getWorld().getObjectsAt(-getImage().getWidth()/2, getY() + getImage().getHeight()/2 + 1, Background.class);
        if (bg1 != null) {
            for (Background bgObject : bg1) {
                if (bgObject.equals(bg)) {
                    return true;
                }
            }
        }
        if (bg2 != null) {
            for (Background bgObject : bg2) {
                if (bgObject.equals(bg)) {
                    return true;
                }
            }
        }
        if (bg3 != null) {
            for (Background bgObject : bg3) {
                if (bgObject.equals(bg)) {
                    return true;
                }
            }
        }
        return false;
    }
    
    /**
     * Check whether the hero is standing on an earth object.
     * 
     * @return
     *      Returns true if the hero stands on the ground.
     */
    public boolean isOnEarth() {
        int offsetY1 = 0;
        int offsetX1 = 0;
        int offsetY2 = 0;
        int offsetX2 = 0;
        int offsetY3 = 0;
        int offsetX3 = 0;
        switch (getWorld().getGravityDirection()) {
            case 0:
                offsetY1 = getImage().getHeight()/2 + 1;
                offsetY2 = getImage().getHeight()/2 + 1;
                offsetY3 = getImage().getHeight()/2 + 1;
                offsetX2 = getImage().getWidth()/2;
                offsetX3 = -getImage().getWidth()/2;
                break;
            case 1:
                offsetX1 = -getImage().getHeight()/2 - 1;
                offsetX2 = -getImage().getHeight()/2 - 1;
                offsetX3 = -getImage().getHeight()/2 - 1;
                offsetY2 = getImage().getWidth()/2;
                offsetY3 = -getImage().getWidth()/2;
                break;
            case 2:
                offsetY1 = -getImage().getHeight()/2 - 1;
                offsetY2 = -getImage().getHeight()/2 - 1;
                offsetY3 = -getImage().getHeight()/2 - 1;
                offsetX2 = getImage().getWidth()/2;
                offsetX3 = -getImage().getWidth()/2;
                break;
            case 3:
                offsetX1 = getImage().getHeight()/2 + 1;
                offsetX2 = getImage().getHeight()/2 + 1;
                offsetX3 = getImage().getHeight()/2 + 1;
                offsetY2 = getImage().getWidth()/2;
                offsetY3 = -getImage().getWidth()/2;
                break;
        }
        return getWorld().getMaterialNumberAt((int) (getExactX() + offsetX1), (int) (getExactY() + offsetY1)) == 1 || 
            getWorld().getMaterialNumberAt((int) (getExactX() + offsetX2), (int) (getExactY() + offsetY2)) == 1 ||
            getWorld().getMaterialNumberAt((int) (getExactX() + offsetX3), (int) (getExactY() + offsetY3)) == 1;
    }
    /**
     * Check whether the hero is in the air.
     * 
     * @return
     *      Returns true if the hero is not standing on a earth object, in water, in lava, or is hanging in a rope.
     */
    public boolean isOnAir() {
        int offsetY = 0;
        int offsetX = 0;
        switch (getWorld().getGravityDirection()) {
            case 0:
                offsetY = getImage().getHeight()/2 + 1;
                break;
            case 1:
                offsetX = -getImage().getWidth()/2 - 1;
                break;
            case 2:
                offsetY = -getImage().getHeight()/2 - 1;
                break;
            case 3:
                offsetX = getImage().getWidth()/2 + 1;
                break;
        }
        return getWorld().getMaterialNumberAt((int) (getExactX() + offsetX), (int) (getExactY() + offsetY)) == 2;
    }
    /**
     * Check whether the hero is swimming.
     * 
     * @return
     *      Returns true if the hero is in water.
     */
    public boolean isOnWater() {
        int offsetY = 0;
        int offsetX = 0;
        switch (getWorld().getGravityDirection()) {
            case 0:
                offsetY = getImage().getHeight()/2 + 1;
                break;
            case 1:
                offsetX = -getImage().getWidth()/2 - 1;
                break;
            case 2:
                offsetY = -getImage().getHeight()/2 - 1;
                break;
            case 3:
                offsetX = getImage().getWidth()/2 + 1;
                break;
        }
        return getWorld().getMaterialNumberAt((int) (getExactX() + offsetX), (int) (getExactY() + offsetY)) == 3;
    }
    /**
     * Check whether the hero is on lava.
     * 
     * @return
     *      Returns true if the hero is standing 
     */
    public boolean isOnLava() {
        return getWorld().getMaterialNumberAt((int) (getExactX() + getImage().getWidth()/2 - 3), (int) (getExactY() + getImage().getHeight()/2 - 3)) == 4 ||
            getWorld().getMaterialNumberAt((int) (getExactX() - getImage().getWidth()/2 + 3), (int) (getExactY() + getImage().getHeight()/2 - 3)) == 4 ||
            getWorld().getMaterialNumberAt((int) (getExactX() - getImage().getWidth()/2 + 3), (int) (getExactY() - getImage().getHeight()/2 + 3)) == 4 ||
            getWorld().getMaterialNumberAt((int) (getExactX() + getImage().getWidth()/2 - 3), (int) (getExactY() - getImage().getHeight()/2 + 3)) == 4;
    }
}