import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * A LavaObject is a field of lava which kills the player when he touches it. Also some movable objects can be destroyed by lava.
 * 
 * @author Gevater_Tod4711
 * @version 1.0
 */
public class LavaObject extends Background
{
    
    public LavaObject(int width, int height) {
        super(new Lava());
        this.width = width;
        this.height = height;
        getImage().clear();
        getImage().scale(width, height);
        if (Settings.texturLava != null) {
            createTextur();
        }
        else {
            getImage().setColor(material.getMaterialColor());
            getImage().fill();
        }
    }
    
    public void createTextur() {
        GreenfootImage textur = new GreenfootImage(Settings.texturLava);
        for (int i = 0; i < width; i += textur.getWidth()) {
            for (int j = 0; j < height; j += textur.getHeight()) {
                getImage().drawImage(textur, i, j);
            }
        }
    }
}