import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * A SpawnPoint is a special object that spawnes the player when he dies (if the game isn't over then). 
 * SpawnPoints can be visible or invisible.
 * 
 * They are activated when a player touches them. When one spawn point is activated all others are disactivated.
 * 
 * @author Gevater_Tod4711
 * @version 1.0
 */
public class SpawnPoint extends Actor
{
    private boolean activated;
    
    public SpawnPoint() {
        this(false);
    }
    public SpawnPoint(boolean activated) {
        this.activated = activated;
        getImage().clear();
        getImage().scale(100, 100);
    }
    
    public void addedToWorld(World world) {
        if (((GravityWorld) getWorld()).isEditMode()) {
            getImage().fill();
        }
    }
    
    public final void act() {
        if (getWorld().getObjects(BreakMenu.class).isEmpty() && !((GravityWorld) getWorld()).isEditMode()) {
            run();
        }
    }
    
    public void run() {
        if (getOneIntersectingObject(Hero.class) != null) {
            List<SpawnPoint> spawnPoints = getWorld().getObjects(SpawnPoint.class);
            for (SpawnPoint spawnPoint : spawnPoints) {
                spawnPoint.setActivated(false);
            }
            activated = true;
        }
    }
    
    public boolean isActivated() {
        return activated;
    }
    public void setActivated(boolean activated) {
        this.activated = activated;
    }
}